﻿package com.strike.PHPRemoting {
	/* By Josh Strike // josh@joshstrike.com // Use freely and enjoy! */
	import flash.events.*;
	import flash.net.NetConnection;
	import flash.net.ObjectEncoding;
	import flash.display.Sprite;
	import flash.net.Responder;
	import flash.display.Stage;
	
	import flash.utils.Timer;
	
	public class PHPAccess extends Sprite {
				
		public var netDebug:Boolean;
		public var gurl:String;
		public var st:Stage;
		public var resViewer:ResViewer;
		public var rs:NetConnection;
		public var record:Array;
		public var mw:Number;
		public var mh:Number;

		private var resLimit:Number;
		private var callLabel:String;
		private var callWas:Object;
		
		public var lockedExpressions:Object;
		public var errorFunction:Function;
		
		private var r:Object;
		
		private var prog:ProgressMonitor;
		private var hangTimer:Timer = new Timer(1000,3);
		public var pendingCalls:Array = new Array();
		
		public function PHPAccess(gurl:String,st:Stage,netDebug:Boolean,mw:Number,mh:Number,resLimit:Number,lockedExpressions:Object = null, 
								  			errorFunction:Function = null) {
			this.netDebug = netDebug;
			this.resLimit = resLimit;
			this.mw = mw;
			this.mh = mh;
			this.record = new Array();
			this.gurl = gurl;
			this.r = r;
			
			this.lockedExpressions = lockedExpressions;
			this.errorFunction = errorFunction;
			
			this.rs = new NetConnection();
						/*USING AMF0 IS RECOMMENDED AT LEAST UNTIL AMFPHP 2.0 SETTLES ISSUES WITH RECORDSETS & ARRAYS IN THE SAME CALL!!!*/
						this.rs.objectEncoding = flash.net.ObjectEncoding.AMF0;
						/* */
						//trace (gurl);
			this.rs.connect(this.gurl);
			if (netDebug) {
				this.st = st;
				resViewer = new ResViewer(this);
			}
		}
		public function setPending(c:PHPCall):void {
			if (pendingCalls.indexOf(c)<0) {
				pendingCalls.push(c);
			}
			if (!prog) {
				hangTimer = new Timer(50,120);
				hangTimer.addEventListener(TimerEvent.TIMER,this.updatePending,false,0,true);
				hangTimer.addEventListener(TimerEvent.TIMER_COMPLETE,this.tryPending,false,0,true);
				prog = new ProgressMonitor(st,"Lost connection - Trying to reconnect!",{startWith:.01});
				hangTimer.start();
			}
		}
		public function killAllPending():void {
			hangTimer ? hangTimer.stop() : void;
			if (prog) {
				prog.kill();
				prog = null;
			}
			for each (var p:PHPCall in pendingCalls) {
				p = null;
			}
			pendingCalls = [];
			//trace ("PENDING: ABSOLUTELY NOTHING");
		}
		public function clearPending(p:PHPCall):void {
			for each (var p:PHPCall in pendingCalls) {
				pendingCalls.splice(pendingCalls.indexOf(p),1);
				p = null;
			}
			if (pendingCalls.length<1) {
				hangTimer.stop();
				if (prog) {
					prog.kill();
					prog = null;
				}
			}
		}
					

		private function updatePending(evt:TimerEvent):void {
			prog.update("Lost connection - Trying to reconnect!",evt.target.currentCount/120);
		}
		private function tryPending(evt:TimerEvent):void {
			prog.kill();
			prog = null;
			for each (var p:PHPCall in pendingCalls) {
				p.retry();
			}
			pendingCalls = [];
		}
		public function recordResult(rType:String, toFunction:Function, serviceClass:String, dataStr:String) {
			callLabel = serviceClass+" "+rType;
			callWas = {rType:String, serviceClass:serviceClass, label:callLabel, dataStr:dataStr, toFunction:toFunction};
			if (this.record.length>resLimit) {
				this.record.shift();
			}
			this.record.push(callWas);
			if (resViewer) {
				resViewer.updateBox();
			}
		}
		public function destroy():void {
			if (resViewer) {
				resViewer.destroy();
			}
			killAllPending();
			rs.close();
		}
	}
}