﻿package com.strike.PHPRemoting {
	
	import flash.display.Stage;
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import fl.controls.Button;
	
	public dynamic class ProgressMonitor extends Sprite {
		
		private var r:Object;
		private var bg:Sprite = new Sprite();
		private var win:Sprite = new Sprite();
		private var pHolder:Sprite = new Sprite();
		private var tx:TextField = new TextField();
		private var cBtn:Button;
		private var box:Sprite = new Sprite();
		private var bar:Sprite = new Sprite();
		private var stripes:Sprite = new Sprite();
		
		private var str:String;
		private var wid:Number = 300;
		private var hei:Number = 60;
		
		public var cancelFunction:Function;
		public var cancelVar:Object;
		public var startWith:Number;
		
		function ProgressMonitor(r:Stage,str:String,extra:Object = null) {
			this.r = r;
			this.str = str;
			if (extra) {
				
				if (extra.cancelFunction) {
					cancelFunction = extra.cancelFunction;
					hei += 30;
				}
				if (extra.cancelVar) {
					cancelVar = extra.cancelVar;
				}
				if (extra.startWith) {
					startWith = extra.startWith;
				}
			}
			this.drawWin();
		}
		private function drawWin():void {
			pHolder.x = (r.stageWidth/2)-(wid/2);
			pHolder.y = (r.stageHeight/2)-(hei/2);
			
			bg.graphics.beginFill(0xFFFFFF,.3);
			bg.graphics.drawRect(0,0,r.stageWidth,r.stageHeight);
			bg.graphics.endFill();
			bg.addEventListener(MouseEvent.CLICK,this.doNothing,false,0,true);
			addChild(bg);
			
			win.graphics.lineStyle(3,0xFFFFFF,1,true);
			win.graphics.beginFill(0x0099FF);
			win.graphics.drawRoundRect(0,0,wid,hei,24);
			win.graphics.endFill();
			pHolder.addChild(win);
			
			tx.x = 10;
			tx.y = 10;
			tx.width = wid-20;
			tx.height = 26;
			tx.text = str;
			tx.setTextFormat(new TextFormat("Arial",14,0xFFFFFF,null,null,null,null,null,"center"));
			//tx.embedFonts = true;
			tx.selectable = false;
			pHolder.addChild(tx);
			
			box.graphics.lineStyle(1,0xFFFFFF,1,true);
			box.graphics.beginFill(0xFFFFFF,1);
			box.graphics.drawRoundRect(10,0,wid-20,16,16);
			box.graphics.endFill();
			box.y = 34;
			pHolder.addChild(box);
			
			drawBar(startWith ? startWith : 0.1);
			bar.x = 11;
			bar.y = 35;
			pHolder.addChild(bar);
			
			if (cancelFunction != null) {
				cBtn = new Button();
				cBtn.label = "Cancel";
				cBtn.x = wid-cBtn.width-10;
				cBtn.y = hei-cBtn.height-10;
				cBtn.addEventListener(MouseEvent.CLICK,this.gotCancel,false,0,true);
				pHolder.addChild(cBtn);
			}			
			
			addChild(pHolder);
			r.addChild(this);
		}
		private function doNothing(... args) {
			//nothing//
		}
		private function gotCancel(evt:MouseEvent) {
			cancelFunction(cancelVar);
		}
		public function update(str:String,prog:Number) {
			this.str = str;
			tx.text = str;
			tx.setTextFormat(new TextFormat("Arial",14,0xFFFFFF,null,null,null,null,null,"center"));
			drawBar(prog);
		}
		private function drawBar(prog:Number):void {
			bar.graphics.clear();
			bar.graphics.beginFill(0x0099FF,1);
			bar.graphics.drawRoundRect(0,0,prog*(wid-20),15,16);
			bar.graphics.endFill();			
		}
		public function kill() {
			r.contains(this) ? r.removeChild(this) : void;
		}
	}
}